Skip to content
The Things Stack documentation home
Getting Started Concepts Cloud Enterprise Integrations API Hardware
Getting Started Concepts
Cloud Enterprise
Integrations API Hardware
Get The Things Stack

    Recent searches

      Popular pages

      • Getting Started
      • Adding Gateways
      • Adding Devices
      • Payload Formatters
      • Webhooks
      • Authentication

      No results for “”.

      • Check the spelling, or try fewer or more general words.
      • Ask the community on The Things Network Forum
      • Contact support
      ↑↓ to navigate ↵ to open Esc to close

      API

      • Overview
      • Concepts
      • Reference
        • HTTP(REST)
        • gRPC
          • Application APIs
          • Application Package APIs
          • Application Pub/Sub APIs
          • Application Server APIs
          • Application Webhook APIs
          • Client APIs
          • Crypto Operations APIs
          • End Device APIs
          • Events API
          • Gateway APIs
          • Gateway Server APIs
          • Identity Server APIs
          • Join Server APIs
          • Network Operations Center APIs
          • Network Server APIs
          • Organization APIs
          • Packet Broker APIs
          • Storage Integration API
          • Tenant APIs
          • User APIs

      Application Webhook APIs

      Updated 14 May 2024 Edit on GitHub
      Copy page
      • View as MarkdownThis page as plain text
      • Open in ChatGPTAsk questions about this page
      • Open in ClaudeAsk questions about this page

      List of Application Webhook APIs.

      The ApplicationWebhookRegistry service

      Method ApplicationWebhookRegistry.Get
      Request type GetApplicationWebhookRequest
      Response type ApplicationWebhook
      HTTP bindings

      GET /api/v3/as/webhooks/{ids.application_ids.application_id}/{ids.webhook_id}

      Method ApplicationWebhookRegistry.GetFormats
      Request type google.protobuf.Empty
      Response type ApplicationWebhookFormats
      HTTP bindings

      GET /api/v3/as/webhook-formats

      Method ApplicationWebhookRegistry.GetTemplate
      Request type GetApplicationWebhookTemplateRequest
      Response type ApplicationWebhookTemplate
      HTTP bindings

      GET /api/v3/as/webhook-templates/{ids.template_id}

      Method ApplicationWebhookRegistry.Set
      Request type SetApplicationWebhookRequest
      Response type ApplicationWebhook
      HTTP bindings

      PUT /api/v3/as/webhooks/{webhook.ids.application_ids.application_id}/{webhook.ids.webhook_id}

      POST /api/v3/as/webhooks/{webhook.ids.application_ids.application_id}

      Method ApplicationWebhookRegistry.List
      Request type ListApplicationWebhooksRequest
      Response type ApplicationWebhooks
      HTTP bindings

      GET /api/v3/as/webhooks/{application_ids.application_id}

      Method ApplicationWebhookRegistry.ListTemplates
      Request type ListApplicationWebhookTemplatesRequest
      Response type ApplicationWebhookTemplates
      HTTP bindings

      GET /api/v3/as/webhook-templates

      Method ApplicationWebhookRegistry.Delete
      Request type ApplicationWebhookIdentifiers
      Response type google.protobuf.Empty
      HTTP bindings

      DELETE /api/v3/as/webhooks/{application_ids.application_id}/{webhook_id}

      Messages

      Message ApplicationIdentifiers

      Show object example
      {
        "application_id": "",
      }

      Fields:

      Field application_id
      Type string
      Description

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Message ApplicationWebhook

      Show object example
      {
        "ids": {},
        "created_at": "0001-01-01T00:00:00Z",
        "updated_at": "0001-01-01T00:00:00Z",
        "base_url": "",
        "headers": {},
        "format": "",
        "template_ids": {},
        "template_fields": {},
        "downlink_api_key": "",
        "uplink_message": {},
        "uplink_normalized": {},
        "join_accept": {},
        "downlink_ack": {},
        "downlink_nack": {},
        "downlink_sent": {},
        "downlink_failed": {},
        "downlink_queued": {},
        "downlink_queue_invalidated": {},
        "location_solved": {},
        "service_data": {},
        "health_status": {},
        "field_mask": {},
        "queue": {},
        "paused": false,
        "custom_ca": "",
      }

      Fields:

      Field ids
      Type ApplicationWebhookIdentifiers
      Description

      required

      Field created_at
      Type google.protobuf. Timestamp
      Field updated_at
      Type google.protobuf. Timestamp
      Field base_url
      Type string
      Description

      Base URL to which the message’s path is appended.

      uri

      Field headers
      Type map of string to string
      Description

      HTTP headers to use.

      max_pairs: 50

      max_len (key): 64

      max_len (value): 4096

      Field format
      Type string
      Description

      The format to use for the body. Supported values depend on the Application Server configuration.

      max_len: 20

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Field template_ids
      Type ApplicationWebhookTemplateIdentifiers
      Description

      The ID of the template that was used to create the Webhook.

      Field template_fields
      Type map of string to string
      Description

      The value of the fields used by the template. Maps field.id to the value.

      Field downlink_api_key
      Type string
      Description

      The API key to be used for downlink queue operations. The field is provided for convenience reasons, and can contain API keys with additional rights (albeit this is discouraged).

      max_len: 128

      Field uplink_message
      Type ApplicationWebhook.Message
      Field uplink_normalized
      Type ApplicationWebhook.Message
      Field join_accept
      Type ApplicationWebhook.Message
      Field downlink_ack
      Type ApplicationWebhook.Message
      Field downlink_nack
      Type ApplicationWebhook.Message
      Field downlink_sent
      Type ApplicationWebhook.Message
      Field downlink_failed
      Type ApplicationWebhook.Message
      Field downlink_queued
      Type ApplicationWebhook.Message
      Field downlink_queue_invalidated
      Type ApplicationWebhook.Message
      Field location_solved
      Type ApplicationWebhook.Message
      Field service_data
      Type ApplicationWebhook.Message
      Field health_status
      Type ApplicationWebhookHealth
      Field field_mask
      Type google.protobuf. FieldMask
      Field queue
      Type ApplicationWebhookQueue
      Field paused
      Type bool
      Description

      Set to temporarily pause forwarding uplink data to this end point and receiving downlinks from this end point.

      Field custom_ca
      Type bytes
      Description

      Custom CA certificate for the server where the webhooks are sent to. PEM formatted.

      max_len: 8192

      Message ApplicationWebhook.Message

      Show object example
      {
        "path": "",
      }

      Fields:

      Field path
      Type string
      Description

      Path to append to the base URL.

      max_len: 64

      Message ApplicationWebhookFormats

      Show object example
      {
        "formats": {},
      }

      Fields:

      Field formats
      Type map of string to string
      Description

      Format and description.

      Message ApplicationWebhookHealth

      Restrictions:
      • Only one of healthy, unhealthy can be set.
      Show object example
      {
        "healthy": {},
        "unhealthy": {},
      }

      Fields:

      Field healthy
      Type ApplicationWebhookHealth.WebhookHealthStatusHealthy
      Field unhealthy
      Type ApplicationWebhookHealth.WebhookHealthStatusUnhealthy

      Message ApplicationWebhookHealth.WebhookHealthStatusUnhealthy

      Show object example
      {
        "failed_attempts": 0,
        "last_failed_attempt_at": "0001-01-01T00:00:00Z",
        "last_failed_attempt_details": {},
      }

      Fields:

      Field failed_attempts
      Type uint64
      Field last_failed_attempt_at
      Type google.protobuf. Timestamp
      Description

      required

      Field last_failed_attempt_details
      Type ErrorDetails

      Message ApplicationWebhookHealth.WebhookHealthStatusHealthy

      Show object example
      {
      }

      Fields:

      Message ApplicationWebhookIdentifiers

      Show object example
      {
        "application_ids": {},
        "webhook_id": "",
      }

      Fields:

      Field application_ids
      Type ApplicationIdentifiers
      Description

      required

      Field webhook_id
      Type string
      Description

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Message ApplicationWebhookQueue

      Show object example
      {
        "enabled": null,
      }

      Fields:

      Field enabled
      Type google.protobuf. BoolValue

      Message ApplicationWebhooks

      Show object example
      {
        "webhooks": [],
      }

      Fields:

      Field webhooks
      Type repeated ApplicationWebhook
      Description

      Message ApplicationWebhookTemplateIdentifiers

      Show object example
      {
        "template_id": "",
      }

      Fields:

      Field template_id
      Type string
      Description

      max_len: 36

      pattern: ^[a-z0-9](?:[-]?[a-z0-9]){2,}$

      Message ErrorDetails

      Error details that are communicated over gRPC (and HTTP) APIs. The messages (for translation) are stored as “error::”.

      Show object example
      {
        "namespace": "",
        "name": "",
        "message_format": "",
        "attributes": {},
        "correlation_id": "",
        "cause": {},
        "code": 0,
        "details": [],
      }

      Fields:

      Field namespace
      Type string
      Description

      Namespace of the error (typically the package name in The Things Stack).

      Field name
      Type string
      Description

      Name of the error.

      Field message_format
      Type string
      Description

      The default (fallback) message format that should be used for the error. This is also used if the client does not have a translation for the error.

      Field attributes
      Type google.protobuf. Struct
      Description

      Attributes that should be filled into the message format. Any extra attributes can be displayed as error details.

      Field correlation_id
      Type string
      Description

      The correlation ID of the error can be used to correlate the error to stack traces the network may (or may not) store about recent errors.

      Field cause
      Type ErrorDetails
      Description

      The error that caused this error.

      Field code
      Type uint32
      Description

      The status code of the error.

      Field details
      Type repeated google.protobuf. Any
      Description

      The details of the error.

      Message GetApplicationWebhookRequest

      Show object example
      {
        "ids": {},
        "field_mask": {},
      }

      Fields:

      Field ids
      Type ApplicationWebhookIdentifiers
      Description

      required

      Field field_mask
      Type google.protobuf. FieldMask

      Message GetApplicationWebhookTemplateRequest

      Show object example
      {
        "ids": {},
        "field_mask": {},
      }

      Fields:

      Field ids
      Type ApplicationWebhookTemplateIdentifiers
      Description

      required

      Field field_mask
      Type google.protobuf. FieldMask

      Message ListApplicationWebhooksRequest

      Show object example
      {
        "application_ids": {},
        "field_mask": {},
        "limit": 0,
        "page": 0,
      }

      Fields:

      Field application_ids
      Type ApplicationIdentifiers
      Description

      required

      Field field_mask
      Type google.protobuf. FieldMask
      Field limit
      Type uint32
      Description

      lte: 1000

      Field page
      Type uint32

      Message ListApplicationWebhookTemplatesRequest

      Show object example
      {
        "field_mask": {},
      }

      Fields:

      Field field_mask
      Type google.protobuf. FieldMask

      Message SetApplicationWebhookRequest

      Show object example
      {
        "webhook": {},
        "field_mask": {},
      }

      Fields:

      Field webhook
      Type ApplicationWebhook
      Description

      required

      Field field_mask
      Type google.protobuf. FieldMask
      ← Application Server APIs Client APIs →

      On this page

      • The ApplicationWebhookRegistry service
      • Messages

      Sections

      Getting Started

      Concepts

      Cloud

      Enterprise

      Integrations

      API

      Hardware

      Sitemap

      View our Sitemap

      Contributing

      GitHub

      About Us

      The Things Industries

      Privacy Policy

      Cookie settings

      Cookie Settings

      We use cookies to enhance your experience, analyze site traffic and deliver personalized content. Read our Privacy Policy.

      Cookie categories